//KzR.cs

//audio
datablock AudioProfile(KzRActivateSound)
{
   filename    = "./KzRActivate.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(KzRShot1Sound)
{
   filename    = "./KzRShot1.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(KzRHitSound)
{
   filename    = "./KzRHit.wav";
   description = AudioClose3d;
   preload = true;
};


//muzzle flash effects
datablock ParticleData(KzRFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 450;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/nut";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.3 0 1";
	colors[1]     = "1 1 1 0.2";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(KzRFlashEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 0.4;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "KzRFlashParticle";

   uiName = "KzR Flash";
};

datablock ParticleData(KzRSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 670;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0 0 100 1";
	colors[1]     = "0 0 100 0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(KzRSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "KzRSmokeParticle";

   uiName = "KzR Smoke";
};


datablock ParticleData(KzRExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/nut";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.4 0.9 0.2 1";
	colors[1]     = "0 0.4 0.2 0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(KzRExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 20;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "KzRExplosionParticle";

   useEmitterColors = true;
   uiName = "KzR Hit Dust";
};


datablock ParticleData(KzRExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/nut";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 0.0 0.9";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 2.0;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(KzRExplosionRingEmitter)
{
	lifeTimeMS = 500;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "KzRExplosionRingParticle";

   useEmitterColors = true;
   uiName = "KzR Hit Flash";
};

datablock ExplosionData(KzRExplosion)
{
   //explosionShape = "";
	soundProfile = KzRHitSound;

   lifeTimeMS = 150;

   particleEmitter = wrenchExplosionemitter;
   particleDensity = 5000;
   particleRadius = 20;

   emitter[0] = KzRExplosionRingEmitter;
   emitter[1] = KzRExplosionEmitter;

   faceViewer     = true;
   explosionScale = "10 10 10";

   shakeCamera = true;
   camShakeFreq = "22.0 24.0 22.0";
   camShakeAmp = "8.0 8.0 8.0";
   camShakeDuration = 1.5;
   camShakeRadius = 100.0;

   // Dynamic light
   lightStartRadius = 40;
   lightEndRadius = 80;
   lightStartColor = "0.0 4000.0 0.0";
   lightEndColor = "0 0 0";

   damageRadius = 4;
   radiusDamage = 800;

   impulseRadius = 4;
   impulseForce = 5000;
};


AddDamageType("KzR",   '<bitmap:add-ons/Weapon_KzR/CI_KzR> %1',    '%2 <bitmap:add-ons/Weapon_KzR/CI_KzR> %1',1.2,1);
datablock ProjectileData(KzRProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 1000;
   directDamageType    = $DamageType::KzR;
   radiusDamageType    = $DamageType::KzR;
   impactImpulse	    	= 5000;
   verticalImpulse	  	= 1000;
   explosion          	  = KzRExplosion;
   particleEmitter    	  = ""; //KzRTrailEmitter;

   brickExplosionRadius = 4;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 60;
   brickExplosionMaxVolume = 4000;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2000;  //max volume of bricks that we can destroy if they aren't connected to the ground  

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 1023;
   fadeDelay           = 1000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 20;
   lightColor  = "0.0 4.0 0.0";

   uiName = "KzR Capsule";
};

//////////
// item //
//////////
datablock ItemData(KzRItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./KzR.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "KzR";
	iconName = "./icon_KzR";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = KzRImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(KzRImage)
{
   // Basic Item properties
   shapeFile = "./KzR.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = KzRProjectile;
   projectileType = Projectile;

	//casing = KzRShellDebris;
	//shellExitDir        = "1.0 -1.3 1.0";
	//shellExitOffset     = "0 0 0";
	//shellExitVariance   = 15.0;	
	//shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = KzRItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = "";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= KzRActivateSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= KzRFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= KzRShot1Sound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= KzRSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 2.0;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";

};

function KzRProjectile::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e)
   {
      if(%col.dataBlock.className $= "Glass" && !%col.indestructable)
      {
         %col.explode();
      }
      Parent::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e);
   }

